<#--  树导航参数  -->
    /**
     * 获取导航项视图参数
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${view.codeName}ComponentBase
     */
    public getExpItemView(arg: any = {}): any {
        if (!arg) {
            arg = {};
        }
        let expmode = arg.viewid.toUpperCase();
        if (!expmode) {
            expmode = '';
        }

        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("EXPITEM:")==0)>
        <#assign newdataview=view.getRefPSAppView(viewref,true) >
        <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is(expmode, '${viewref?substring(8)}')) {
            return { embedviewid: '${newdataviewref.getEmbedId()}', routelink:'${viewref?substring(8)?lower_case?replace(':','__')?lower_case?replace('@','__')}'<#if newdataviewref.getViewParam()??>, viewparam: ${newdataviewref.getViewParam().toString()}</#if> };
        }
        </#if>
        </#list>

        return undefined;
    }


    /**
     * 获取新建数据视图参数
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${view.codeName}ComponentBase
     */
    public getNewDataView(arg: any = {}): any {
        if (!arg) {
            arg = {};
        }
        let newmode = arg.srfnewmode;
        if (!newmode) {
            newmode = '';
        }

        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("NEWDATA:")==0)>
        <#assign newdataview=view.getRefPSAppView(viewref,true) >
        <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is(newmode, '${viewref?substring(8)}')) {
            <#if (newdataviewref.getViewParam()??)>
            Object.assign(arg, ${newdataviewref.getViewParam()});
            </#if>
        return {  title: '${newdataview.getTitle(newdataviewref)}',    openMode:'${newdataview.getOpenMode(newdataviewref)}',    height: ${newdataview.getHeight(newdataviewref)?c},  width: ${newdataview.getWidth(newdataviewref)?c},
                    layout: 'fit',  maximizable:true,  viewurl:'/${newdataview.getPSAppModule().codeName?lower_case}/${newdataview.codeName?lower_case}.jsp',  viewparam:arg };
        }
        </#if>
        </#list>

        let parts = newmode.split('@');
        if (parts.length !== 2) {
            return null;
        }
        
        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("NEWDATA@")==0)>      
        <#assign newdataview=view.getRefPSAppView(viewref,true) >
        <#assign newdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is(parts[1], '${viewref?substring(8)}')) {
            <#if (newdataviewref.getViewParam()??)>
            Object.assign(arg, ${newdataviewref.getViewParam()});
            </#if>
            let view = { title: '${newdataview.getTitle(newdataviewref)}', openMode:'${newdataview.getOpenMode(newdataviewref)}', height: ${newdataview.getHeight(newdataviewref)?c}, width: ${newdataview.getWidth(newdataviewref)?c},
                layout: 'fit', maximizable:true, viewurl:'/${newdataview.getPSAppModule().codeName?lower_case}/${newdataview.codeName?lower_case}.jsp', viewparam:arg };
            return view;
        }
        </#if>
        </#list>

        return undefined;
    }

    /**
     * 获取编辑数据视图参数
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${view.codeName}ComponentBase
     */
    public getEditDataView(arg: any = {}): any {
        let editmode = arg.srfeditmode;
        if (!editmode) {
            editmode = '';
        }
        let parts = editmode.split('@');
        if (parts.length !== 2) {
            return null;
        }
        
        <#list view.getAppViewRefModes() as viewref>
        <#if (viewref?index_of("EDITDATA@")==0)>
        <#assign editdataview=view.getRefPSAppView(viewref,true) >
        <#assign editdataviewref=view.getPSAppViewRef(viewref,true) >
        if (Object.is( parts[1], '${viewref?substring(9)}')) {
            <#if (editdataviewref.getViewParam()??)>
            Object.assign(arg, ${editdataviewref.getViewParam()})
            </#if>
        return {  title: '${editdataview.getTitle(editdataviewref)}', openMode:'${editdataview.getOpenMode(editdataviewref)}', height: ${editdataview.getHeight(editdataviewref)?c}, width: ${editdataview.getWidth(editdataviewref)?c},
                    layout: 'fit',   maximizable:true,   viewurl:'/${editdataview.getPSAppModule().codeName?lower_case}/${editdataview.codeName?lower_case}.jsp',   viewparam:arg  	};
        }
        </#if>
        </#list>

        return undefined;
    }

    <#if view.getRefPSAppView("NEWDATAWIZARD",true)??>
    <#assign newdatawizardview=view.getRefPSAppView("NEWDATAWIZARD",true) >
    <#assign newdatawizardviewref=view.getPSAppViewRef("NEWDATAWIZARD",true) >
    public getNewDataWizardView(arg: any = {}): any = {} {
        if (!arg) {
            arg = {};
        }
        let view = { modal:true, title: '${newdatawizardview.title}', height: ${newdatawizardview.getHeight(newdatawizardviewref)?c},  width: ${newdatawizardview.getWidth(newdatawizardviewref)?c}, layout: 'fit', 
            // maximizable:true, 
            viewurl:'/${newdatawizardview.getPSAppModule().codeName?lower_case}/${newdatawizardview.codeName?lower_case}.jsp', viewparam:arg };

        return view;
    }
    </#if>