import { IBizUtil } from '@ibizsys/util/IBizUtil';
import { IBizCodeList } from '@ibizsys/util/IBizCodeList';
<#if view.getPSSysCounterRefs()??>
import { IBizUICounterService } from '@ibizsys/util/IBizUICounterService';
</#if>

import { ${viewContorllerName} } from '@ibizsys/app/${viewContorllerName}';

<#list modalviews as modalview>
import { ${modalview.codeName}ModalService } from 'app/pages/${ngfilename('${modalview.getPSAppModule().codeName}')}/${ngfilename('${modalview.codeName}')}/${ngfilename('${modalview.codeName}')}-modalservice';
</#list>

<#if view.getPSControls()??>
<#if (view.getAllPSControls()?? && view.getAllPSControls()?size > 0)>
import {
  <#list view.getAllPSControls() as ctrl>
  <#if pfstyle.hasPSPFCtrlTempls(ctrl,'SERVICE_TS')>
  ${srfclassname('${ctrl.name}')}Service,
  </#if>
  </#list>
} from './${viewname}.service';
</#if>
</#if>

/**
 * 发布视图控制器基类，不可修改
 * 
 * @export
 * @class ${view.codeName}ComponentBase
 * @extends {${viewContorllerName}}
 */
export class ${view.codeName}ComponentBase extends ${viewContorllerName} {

    <#list modalviews as modalview>
    ibiz${modalview.codeName}ModalService: ${modalview.codeName}ModalService;
    </#list>

    <#if view.getPSControls()??>
    <#list view.getAllPSControls() as ctrl>
    <#if pfstyle.hasPSPFCtrlTempls(ctrl,'SERVICE_TS')>
    ${ctrl.name}: ${srfclassname('${ctrl.name}')}Service;
    </#if>
    </#list>
    </#if>

    constructor(opts) {
        super(opts);
        <#if view.getAllPSControls()??>
        <#list view.getAllPSControls()?reverse as ctrl>
        <#if pfstyle.hasPSPFCtrlTempls(ctrl,'SERVICE_TS')>

        this.${ctrl.name} = new ${srfclassname('${ctrl.name}')}Service({
            name: '${ctrl.name}',
            modal: opts.modal ,
            modalSubject: opts.modalSubject ,
            viewController: this ,
            url: '/${app.getAppFolder()}/${view.getPSAppModule().codeName}/${view.codeName}.do',
            notification: this.$notification,
        });
        this.regControl('${ctrl.name}', this.${ctrl.name});
        </#if>
        </#list>
        </#if>

        <#list modalviews as modalview>
        this.ibiz${modalview.codeName}ModalService = opts.${modalview.codeName}ModalService;
        </#list>
    }