import { Observable } from 'rxjs/Observable';
import { RouterModule, Router, ActivatedRoute, Data, Routes } from '@angular/router';
import { CommonModule } from '@angular/common';
import { Component, NgModule, OnDestroy } from '@angular/core';
import { IBizAppService } from '@ibizsys/IBizAppService';

import { ${view.codeName}Module } from './${viewname}.module';
import { ${view.codeName}Component } from './${viewname}';

@Component({
    template: `<router-outlet></router-outlet>`,
})
export class ${view.codeName}shellComponent implements OnDestroy {

    /**
     * 激活路由参数
     * 
     * @private
     * @type {*}
     * @memberof ${view.codeName}shellComponent
     */
    private activatedRouteData: any = {};

    /**
     * Creates an instance of ${view.codeName}shellComponent.
     * @param {Router} router 
     * @param {ActivatedRoute} activatedRoute 
     * @param {IBizAppService} iBizAppService 
     * @memberof ${view.codeName}shellComponent
     */
    constructor(private router: Router, private activatedRoute: ActivatedRoute, private iBizAppService: IBizAppService) {
        this.activatedRoute.data.subscribe((data: Observable<Data>) => {
            if (Object.keys(data).length === 0) {
                return;
            }
            Object.assign(this.activatedRouteData, { routerurl: this.router.url });
            Object.assign(this.activatedRouteData, data);
            const _data: any = this.iBizAppService.addActivatedRouteDatas(this.activatedRouteData);
            if (_data && Object.keys(_data).length > 0) {
                Object.assign(this.activatedRouteData, _data);
            }
        });
    }

    /**
     * 部件销毁
     * 
     * @memberof ${view.codeName}shellComponent
     */
    public ngOnDestroy(): void {
        if (Object.keys(this.activatedRouteData).length === 0) {
            return;
        }
        this.iBizAppService.deleteActivatedRouteDatas(this.activatedRouteData);
    }

}